%{
open Commands
%}

%token X Y PickT DropT EOF
%token <int>RobotId
%token <Commands.direction>Direction
%token <int>Coord

%start main

%type <Commands.event list> main

%%

main:
    commandList EOF	       { $1 }

commandList:
                           { [] }
|  command commandList     { ($1@$2) }

command:
    RobotId actionList { match $2 with
                           [] -> (* indicates a no-op *) [($1, Pick[])] 
                         | l  -> (List.map (fun action -> ($1,action)) $2) }

actionList:
                      { [] }
| action actionList   { $1@$2 }

action:
    directionList  { [Move($1)] }
|   X Coord Y Coord directionList { [Appear(($2, $4), $5)] }
|   packageList { $1 }

directionList:
                { [] }
| Direction directionList {$1::$2}

packageList:
                { [] }
| PickT Coord packageList { (Pick([$2])::$3) }
| DropT Coord packageList { (Drop([$2])::$3) }




